VERSION HISTORY:
----------------

v0.1.1.x
R Client / Sever 0.1.1.0 (Released to SourceForge 10.08.05)
+ New Version of MegaMek with isRepairing() and setRepairing(). awaiting for patch to be accepted.
+ Added more advance repair code.
+ Added RepairUnitCommand.java. This command parased out what the player wants repaired on their unit.
+ Added ModFullRepairCommand.java. allows mods to fully repair any unit any user has.
+ Added repairTrackingThread.java runs if advancerepair is set, runs as a thread off CampaignMain.cm
+ BUG: Defender not generating components after win when BV < BV for adjustment.
+ GUI for "CheckArmyEligibility"
+ New command: "CheckArmyEligibility", used to see whether an army is legal for an aattack type

V0.1.0.x
+ Only show "Cancel" in games manu if player is fighting.
+ BUG: Autoscrap of unmaintained units should trigger money & flu penalties.
+ BUG: Displaying Defender Component message when components where = 0
+ BUG: Missing units from Bays. units to being placed back into House queue when they couldn't be bought.
R Client 0.1.0.3 Server 0.1.0.6
+ BUG: clients sending repair data to server when AdvanceRepair was off.
+ BUG: DefenderPPUnitAdjustment and DefenderPPBVAdjustment where switched when creating vars.
+ Fixed typo in shortResolver.
R Server 0.1.0.5
+ BUG: factoriesSearched was not adding selected factory when attack won and was taking components. could cause inf loop.
R Client 0.1.0.2
+ BUG: Factory refresh option still killing Rewards Dialog. Had to Make a change to isOwner and getOwner in Planet.java
+ BUG: Rewards Dialog not displaying anything but units. 
R Server 0.1.0.4
+ BUG: All Components where using the same array of vectors.
+ Added Gui to HQ to select advance repair dialog, only visible if advance repair is on
+ Added AdvanceRepairDialog.java
+ BUG: Possible fix to errors w/ defection unit % losses.
+ Changed Night Temp Mod to Temp Reduction in the AdvanceTerrain Dialog
+ BUG: AdvanceTerrain Night Temp Mod was adding to temp instead of reducing.
+ BUG: setMOTD command was trying to parse rank syntax even if it wasn't there.
+ Remove extranious debug messages from ServerMegaMekGameOptoins.java
R Server 0.1.0.3
+ BUG: Resetting ShortResolver variables before checking current status of ShortOperation
+ Added new mod command "HardTermiante," which can kill any operation. Should be used sparingly.
+ Changed UnitUtils.unitBattleDamage(Entity, boolean) to set ammo bins to 0 when crit is damaged.
+ Added colors to HQ for advance repair, units with crits damaged are Red units with only armor damage are yellow
+ Added UnitUtils.getEngineType(Entity unit)
+ Added UnitUtils.getNumberOfEngineCrits(Entity unit)
+ Added check to SPlayer.hasEnginedUnits() to see if advance repair is on. if not then dont bother checking.
R Server 0.1.0.2
+ BUG: Impossible to activate b/c of boolean inversion in engine hit check code.
+ BUG: Improperly handling win/loss percentage modifiers
+ moved a advance repair functions from Unit.java to UnitUtils.java
+ Added common.utils.UnitUtils.java
R Server 0.1.0.1
+ BUG: NPE in ShortValidator, trying to parseInt a null.
+ Add begining of Advanced repair. Defaults to off.
+ BUG: influence.isOwner() not changed for new planet influence code.
+ Change to component payouts - needs corresponding documentation.
+ OperationsEditor GUI's for Faction exclusivity options.
+ New Ops paramaters: "LegalAttackFactions" and "IllegalAttackFactions".
+ New Ops paramaters: "LegalDefendFactions" and "IllegalDefendFactions".
+ OperationsEditor GUI's for Spread options and ProtosMustbeGrouped
+ New Ops paramaters: "CountVehsForSpread", "CountProtosForSpread" and "CountInfForSpread"
+ New Ops paramaters: "MaxAttackUnitBVSpread", "MaxDefenderUnitBVSpread"
+ New Ops paramater: "ProtosMustbeGrouped"
+ OperationsEditor GUI's for for MinAttackerUnitBV, MinDefenderUnitBV, MaxAttackerUnitBV and MaxDefenderUnitBV
+ New Ops paramaters: "MinAttackerUnitBV" and "MinDefenderUnitBV"
+ New Ops paramaters: "MaxAttackerUnitBV" and "MaxDefenderUnitBV"
+ RFE: Show user level in /c check
+ R Client/Server 0.1.0.0 (Released to SourceForge 9.29.05)
+ Added Vertigo to contributors.txt's documentation section
+ BUG: Rewards points dialog always showing 1 flu unit when using rp to get flu. correcdt flu was being given.
+ BUG: CUnit.SetData() was returning false on OMG's need to return true so the unit would be added to the hangar
+ R Client/Server 0.1.0.0-RC3
+ CampaignMain only loads Calculated Costs now when UseCalculatedCosts is set to true at startup.
+ Disabled UseCalculatedCosts as MM does not caluclate costs for Protomeks or some Infantry/BA
+ Removed (ALPHA) text from CMainFrame.jMenuHelpHelp_actionPerformed
+ Added mwclient.getserverConfigs("NewbieHouseName") to CMainFrame.jMenuHelpHelp_actionPerformed to send Newbie house name instead of SOL
+ Removed ONLINEHELP tag from MMNetHyperLinkListener as it was duplicated in CMainFrame.jMenuHelpHelp_actionPerformed and used.
+ RFE 1291173: New Mtch Request Options
+ Moved BannedAmmoDialog from client.gui.dialog to admin.dialog.
+ BUG: Incorrect ELO showing for loser.
+ BUG: House banned ammo was only loading the first ammo and not parsing the rest of the string.
+ Removed Extranious logging from MD5 Commands.
+ Remove xstream from MWclient and DatafetcherClient saved Last time stamp as long without xml.
+ Added HouseBannedAmmoMD5
+ Added HouseBannedAmmo
+ Added loadHouseBannedAmmo
+ Corrected bad coded replaced ""+(int,long,double)var with Long.toString(long) Integer.toString(int) Double.toString(double);
+ Added loadServerBannedAmmo method to MWClient.jar
+ Changed SetServerBanned ammo call in MekWarsAdmin.jar to call ned Banned ammo Dialog.
+ Added Banned Ammo dialog to allow SO's an easier time to set banned ammo.
+ Added ServerBannedAmmoMD5 to check to see if client banned ammo is the same as the servers.
+ Added ServerBannedAmmo command to allow clients to pull only the server Banned ammo any time
+ Added Quick Study and Gifted to the traits dialog.
+ New MM with fixes to Terrain bugs, Thin Ice. Also fixes to double engine explosions and TAG bugs.
+ Typo in Operations Tool tips.
+ BUG fixed second usage of QuickStudy in shortResolver.
+ BUG building stopped reporting.
+ R Client/Server 0.1.0.0-RC2
+ Do not allow players to change host names unless "Convert to Ded" is checked.
+ Removed "PlayName" feature.
+ BUG: QuickStudy giving 5% of normal pilot XP, instead of 105%.
+ BUG: looking for "BL*" instead of "BL" when processing autoreports
+ added 1 to the id for unbanip as the list starts at 1 but the remove code starts at 0
+ comsetic change to the ban list command
+ rearranged windows in OpEditor.
+ Added Lvl 3 Targeting systems checks to Customize box. now C3m and C3mm cannot use them.
+ R Client/Server 0.1.0.0-RC1
+ Updated contributors.txt to reflect Vertigo's image work
+ Show attack menus in HQ when player is not active/is fighting.
+ Filter attack menus when right clicking in HQ so only legal attacks for given army are shown.
+ Added "Max" cursor to HQ.
R Client/Server 0.1.0.0-Alpha11
+ Potential fix for pilot-salvage bugs. Needs testing.
+ BUG: Even if a player's units could not gain XP, it was being shown in post-game.
+ BUG: Was possible to defect while in a game.
+ Revised ShortOperation - no longer stores any direct references to SPlayers or SArmies.
0 This makes the code slower; however, also eliminates possibility  of dis/reconnect resulting in a dummy SPlayer.
+ added GUI and addming command for setting Planets own min ownership
+ RFE 1298071: Better handeling of Uncontrolled Planets
+ RFE 1290358: Server Options: planet Control Percentages
+ BUG: "forceBV <= MaxCount" instead of "forceBV >= MaxCount" when determining army weights.
+ Removed all hexes not used by MW.
+ Added <BUILDINGTYPES>1,2,3,4</BUILDINGTYPES> to terrain.xml to allow SO's to pick which buildings to populate.
+ Added new MM Hexes to Client-Dest
+ BUG: Code which gave salvage units to new owners was commented out...
+ BUG: was not clearing the Coords vector between each building. Caused all buildings to be the same Height CF And Type.
+ BUG: RPForDefender was populating baseDefenderExperiencePay in Short Resolver.
+ BUG: BaseAttackerPayExperience was populating baseDefenderRewardPointsPay in Short Resolver
R Client/Server 0.1.0.0-Alpha10
+ BUG: NPE when trying to check if an op has any buildings in it.
+ BUG: sometimes terminating games if second player drops, if first player has dropped and returned.
+ BUG: Ranges not being properly checked during attacks.
+ Remove extraneous copies of planets.xml, terrains.xml from CVS root.
+ Added MM-dev .31.0 to CVS (9.17.05 release)
+ RFE: Strip illegal ammo from a player when he joins a faction.
+ BUG: Buildings not being reset with each new call to ShortResolver.
+ BUG: Scrap thread starting before old threads stopping. Could leave some units unscrappable.
+ RFE: Strip house-illegal ammo from units when added to a player.
+ Blocked code for building terrain until bug can be found
+ Added custom cursors for drag and drop
+ BUG: SOL SHouse.toString() was getting saved for BM units instead of SHouse.getName();
+ Advance Terrain Loaded from XML
+ Advance Terrain Saved to XML
+ Added code to not pay a building op if buildingsLeft > TotalBuildings started for the op
+ BUG: Free techs not being updated after pilot gains AsTech skill.
+ Rename taskdata.log to gamedata.log and same in ./logs/ instead of root.
+ HQ drag and drop. Functional, needs snazzy cursors to provide hints.
+ Commented out code that creates duplicate pilots when you capture one.
+ Remove extra "," from Buy pilots.
+ updated kill messages for !Mek units. Squad Crew and Proto pilot.
+ Added a loop to the thread and moved it to from the host start to the client start.
+ Added thread to delete autosaves every 2 hours for deds. 
+ Added duplicate hex finding code for the building placement. 
+ BUG: ConcurrentModificationException in OperationManager's removeFromAllPossibleDefenderLists().
+ Added AttackerMinBuildingsIfAttackerWins to DefaultOperation. If attacker wins the number of buildings destoyed is floored @ this number.
0 - i.e. keeps defender from screwing attacker by quiting early.
+ Added buildings to operations.
+ BUG: Was returning the level up string before reset exp to Zero
+ BUG: more issues with op buildings data being sent client side.
+ Removed Task tab from the server config and moved the last few filed to combat
+ BUG: if you had more components then needed to AP they would not go down if you had !produce without factories set.[Big time screw up on my part Torren]
+ added Mod Mail warnings when a player uses a command that sends them into welfare, i.e. Sell, Direct Sell, Scrap, Donate, Transfer.
+ updated building defaults in OperationsEditor.DefaultOperation.java
+ updated building defaults in server.campaign.operations.DefaultOperation.java
+ updated buildings map edit constants to match with MM's
+ added MM calls in ClientThread.java to set map edge
+ added GMEP client command call to ShortOperation to setup map edges for attackers and defenders.
+ added RBP client command calls to ShortOperation to setup buildings for that op.
+ added buildings tab to the Operations Editor along with loading and saving said data
+ changed return to continue in updateMenuItems loop so that all menu items can be added even if one bad one is encountered.
+ added terminate commmand to the games menu
+ added color to the attack menu for the Star Map
+ Updated TerminateCommand.java to search for the player if no ID is sent
+ More timely calls to PL|UU - should stop some loser/salvage unit ghosting.
+ BUG: Units owned by losing players getting level up chances
+ added level 3 Clan and IS filters to the unit viewer.
+ RFE: New ops variable - "OnlyAgainstNonFactoryWorlds" [Has GUI]
+ RFE: New ops variable - "OnlyAgainstFactoryWorlds" [Has GUI]
+ Made changes to OperationEditor so it only prints out settings which are not equal to defaults.
+ RFE: "ShowFactionRanks" server config option. Disable to stop house lists on ticks. [Has GUI, Misc tab]
+ BUG: Admins losing levels when using standard defections (all non-admins still reduced)
+ Added disconnection settings and pilot level up settings to ServerConfigDialog
+ Properly handle post-game salvage for a player - cap payment @ task pay amount.
+ BUG: Extra spaces at the end of some pay strings.
+ BUG: Extra <br> after "Recently Completed Games:" on ticks.
+ BUG: ID# not included in finished info.
+ BUG: ShortOperations returning improper defending faction in running info.
+ updated defaultops in opeditor.
+ adding descriptions for building for defaultops
+ Format problems with money and flu in the player status panel
+ BUG: Improper handling of odd numbers of machine guns when rapid fire is enabled.
+ BUG: Play Names not being filtered out of OperatonEntities created by IPU's.
+ Hide Trait Viewer in Client if Server's "chanceforTNforMek" is <= 0
+ BUG: techStrings not assembled properly
+ Begin code to properly handle post-game salvage for a player.
+ New ServerConfig: "TimeToSelectSalvage", # of seconds players have to scrap units afetr game.
+ added UseCommonPilotNameFileOnly to server configs.
+ BUG: Unlocking factory leaves it with ~2 billion miniticks until refresh.
+ Properly handle <= 0 techs in CMainFrame's firing dialog.
+ New Ops Variable: "PayTechsForGame", set false to stop tech payments. [Has GUI]
+ Added client.cmd.RBP.java to transport server Buildings data to the client.
+ Added common.campaign.Buildings.java to setup building params for RMG and Operations
+ BUG: Inverted differential check when levelling pilots
+ BUG: Techs not being paid. boy am I stupid. (@urgru)
+ New Ops Variable: "AllowAgainstNonConq", set false to bar players from using attack vs. nonconq. [Has GUI]
+ New Ops Variable: "AllowNonConqToUse", set false to bar nonconq players from using an attack. [Has GUI]
+ Ignore armies with no legalOperations in weighted army numbers. No PP, no Flu.
+ Prospective fix for null when reconnecting.
+ Enforce newbie restrictions (no unit deaths, pay all as winners, etc) in ShortValidator and ShortResolver
+ Removed "ChangeLanceOnActive" - overhead was silly, and activation minimums can simply be removed.
+ No conquest leeches on non-conq word, from non-conq houses, or by non-conq houses.
+ Add mechstats entries for winning/losing units after games.
+ Added more funcitonality to Placing Random Bulidings for RMG.
+ found another PPQ not updating to the client 
+ fixed typos in the return of flu/money/rp messages
+ If a world is non-conquerable, , reduce all influence exchanges to 0.
+ If one of the houses in a game is non-conquerable, reduce all influence exchanges to 0.
+ Show only armies eligible for an attack type in attack army selection combo box.
+ Updated ServerConfigDialog to properly reflect option removal.
+ Removed *33* server config variables which are obsolete, or from Tasks. See DefaultServerOptions diff for details.
+ Added support for map range rings. Configurable HTML colours - no colour key yet.
+ Revised map popup menu layout.
+ moved getLegalOperations for each from SHouse to CampaignMain so the armies will be populated after all player data is sent.
+ fixed spacing issues with game and modgame commands.
+ BUG: valid operations where not getting pushed down when player was still in memory, army was not getting cleared
+ copied DefaultOPerations.java to OperationsEditor for new defaults!
+ BUG: Client side PPQ not being updated after games and pilots where dispossed.
+ Use PL|RAU when SPlayer.removeArmy() is called instead of PL|SAD. This needs to be tested.
+ Send fewer duplicative PL|SAD commands.
+ BUG: Terrain wasn't being set correctly some Pavement and Ice vars where being set incorrectly.
+ Added Rubble RMG Terrain RUBBLEMINSPOTS RUBBLEMAXSPOTS RUBBLEMINHEXES RUBBLEMAXHEXES
+ Added Fortified RMG Terrain FORTIFIEDMINSPOTS FORTIFIEDMAXSPOTS FORTIFIEDMINHEXES FORTIFIEDMAXHEXES in terrain.xml
+ Initial Client GUI for Operations - a simple "Attack" menu.
+ BUG: Concur Modification exception in OperationManager.tick()
+ BUG: TagAndHomingCombo errors when a ghost army exists.
+ added NoFactoryRepodFolder to repod without any factories or the use of factories.
+ added RewardsRepodFolder to repod with awards and not worry about factories.
+ fixed warning in Browser. Links still work.
+ BUG: turning off factories where still not initilizing some component vectors, causing NPEs, now every gets set to 0.
+ BUG: house components where not getting Initilized with factions.xml
+ added ClientThread.generateRandomBuildings(); to take advantage of the new mapSetting building vars [may need to disable call to get RMG to work still tinkering]
+ removed collections.java from client-dist and server-dist
+ removed collections calls from MW since MM removed there calls.
+ BUG: NPE's in removeFromAllAttackerLists and removeFromAllDefenderLists
+ Client parses OpList.txt lines into a TreeMap, keyed to name.
+ Client compares local OpList.txt MD5 w/ server copy, updates if necessary. 
+ Server generates OpList.txt at startup.
+ Client reads PL|UOE commands sent by ShortValidator's .checkOperations
+ Added .checkOperations() to ShortValidator. Called from all relevant commands, login, and ShortResolver.
0 checkOperations() sends a list of legal attack types for an army to a player, will be used for GUI. 
+ Removed redundant joingame/viewgame Host Menu options from CMainFrame
+ Removed Scan-related code (lastScan and support methods) from SPlayer & SPlayerData
+ Removed Scan-related options from DefaultServerConfig and ServerConfigDialog
+ Removed "Scan" & "Task Status" from Campaign Menu In Client. Added "Games Status".
+ added support to planets.xml so that PROTOMEK and BATTLEARMOR factories can be added.
+ added code to load megamek game options into a static var on the server.
+ If SO's turn off Level 3 targetting, all units reset their targetting after reloading.
+ Mod/Admin support for modterminate/modgames/adminterminateall
0 Farewell, Tasks. We knew ye well.
+ Removed /server/campaign/tasks and related code in other classes.
+ Temporarily disabled AutoJoinCommand.
+ Removed ScanCommand, CancelCommand, JoinCommand, TasksCommand.
+ Renamed ModCancel/ModTasks/AdminCancelAll to ModTerminate/ModGames/AdminTerminateAll
+ Removed JumpToRescueCommand, AskJumpCommand [re-add later]
+ BUG: Forgot to do post-game ELO changes. oops.
+ BUG: "You have stored mail" being double sent.
+ BUG: Player is told that he's already logged in if he leaves/returns mid-game.
+ Small change to skill formatting when buying pilots from a faction.
+ Show new BV of a unit when pilot is exchanged/assigned.
+ Show correct weight class when generating defender-win components.
+ Prospective fix for PL|UBT
+ "You're under attack!" sound for potential defenders when their ChickenThreads start.
+ Removed/commented out InProgressUpdate tracking output
+ CR| generation in client handles 0-CT/Undevastated units more gracefully.
+ Small changes to OperationEntity to better handle destroyed CT and DEVASTATED entities.
+ InProgressUpdate code now handles pilots more smoothly. MM updated to return correct CT IS for destroyed units.
+ UnitCost.java. At server startup all units are loaded and the min and max costs for each weight/type is stored into a vector of vectors
+ Added code to Request and ReqeuestDonated to use MM caculated prices when buying units
+ Added new config var: CostModifier default 1.0 [Needs GUI]
+ Added new config var: UseCalculatedCosts, default false [Needs GUI]
+ MegaMek gameoptions editor now checks MD5 - if no change then it does not send update command.
+ Moved MD5 retrieve for MegaMekGameoptions to its own method
+ Improved handling of ejected pilots when auto-resolving a disconnection.
+ Auto-Resolution of disocnnections. Works well, unless the dropping player comes back. He's told that he's already logged in ...
+ Remove OpEditor.jar from CVS, add to CVS ignore
+ added UnitCosts.java and UnitCosts class to store min and max costs of units when server starts up.
+ began code for allowing SO's to set unit prices based on actual unit costs.
+ fixed bug in Server config menu, search and replace bug. 
+ OperationsDialog was importing the wrong StringTokenizer
+ OpsDisconnectThread added. Will eventually be used to trigger report of games after disconnections.
+ ShortResovler can move games to finished status without autoreport, using info from InProgress trees
+ ShortOperations keep track of units and pilots while running, in InProgess trees
+ ClientThread now reports unit removals to the campaign server
+ Added new config variable: DisconnectionAddUnitsDestroyed; default: 0 units [Has GUI]
+ Added new config variable: DisconnectionAddUnitsSalvage; default: 1 unit [Has GUI]
+ Added new config variable: DisconnectionTimeToReport; default: 600 seconds [Has GUI]
+ added better error reports for OperationsDialog.java
+ added System.getProperty("user.dir") to the FileDialog in OperationsDialog and MWClient.java to open to the correct location.
+ added rank var to setMOTDcommand defaults to commander. new syntax /c setmotd#message#rank
+ Created Operations Editor, OpEditor. Currently only does Short Ops. Long Ops to come.
+ BUG: could pull inf units from house bays.(I'm an idiot --Torren)
+ TYPO DelayPeLeech instead of DelayPerLeech
+ BUG: Another infinite loop while drawing units during offensive raids.
+ BUG: Infinite loop in attacker reporting when factory on target world.
+ Show "Old BV: YYY/New BV: ZZZ" when a unit gains a skill
+ BUG: Strings showing kills had improper punctuation.
+ BUG: Units/armies not being updated in client after level up.
+ BUG: Eliteness check when levelling pilots was inverted (>= instead of <=)
+ BUG: Player unable to engage if one of his finished games is outstanding.
+ BUG: Repair costs aggregating incorrectly
+ changed autobackup thread call from run() to start()
+ BUG: certain Experience defaults missing in DefaultOperation
+ Added player payments (money, exp, etc) to ShortResolver.
+ Fixed several more nulls in salvage, and added <br>'s to salvage lines.
+ BUG: Only check overrun for offboard units.
+ BUG: Improperly mapping strings in ShortResolver. 
+ BUG: trait skill bombs when trying to pull its component skills for skill chance.
+ fixed spacing problem with Op Report in Server Config Dialog
+ Additional salvage code in ShortResolver. Units should now change hands.
+ BUG: sending results from multiple autoreports
+ Additional salvage code in ShortResovler, mostly pertaining to pilot recovery.
+ Added Pilot XP configurability to DefautlOperation
+ Complete revamp of pilot level-up procedures [has GUI]
+ TASK 118392: PreTask Report
+ Added meta-impacts to the ShortResolver (% changing hands, etc). Still no salvage or pay.
+ BUG: defender names were not being cased properly when added to tree.
+ changed output of moneyOrFluMessage so that it prints out the amount sent to the method for the client
+ Revised AorAn to take a capitalization boolean.
+ simplistic (and untested) reporting. should show winners/losers and unlock armies.
+ changed output of moneyOrFluMessage so that it prints out the amount sent to the method
+ added code to not allow Repods when on welfare
+ added support for ICE terrain in MM RMG.
+ BUG: attacking house was not getting captuered units sent to their house bays.
+ fixed typos with chicken leech messages. hasloss boolean not being sent flu and money amounts not being displayed
+ added status change call to operations so icons change to all players.
+ fixed typo in adminmenu
+ sorted Campaignconfig.txt and commandlist.dat for easier MD5 readings.
+ BUG: if op directores didn't exist, wasn't creating them correctly
+ Befuddlingly large ops commit. SO's please look at the comments and, if possible, test.
0 The half-done ops code should not impact production servers, but will make the binaries larger.

V0.0.20.x (Closed 08.25.05 No binary release)
R Client/Server 0.0.20.1
+ added MD5 check to the MegaMekGameOptions file.
+ BUG: problem with cunit loading a client side OMG
+ BUG: Traits where loading incorrectly.
+ BUG: found more commands that got switched from house to faction changed them back to faction.
+ TASK 118308: Level 3 Targeting added to Customize Unit Dialog
+ added code to assign a new trait if a pilot had the trait named none
+ BUG: creatuint and pilots created in faction pools would not assign a trait to the trait skill
+ TASK 118371: Save Server Mails on server until user calls for them
+ BUG 1260312: BA not displaying pilot skills in house bays
+ added GUI grant sub menu to mod userlist menu.
+ added code to /banlist that will not remove old IP/Players if they are past the banning time.(before they where only removed if the player logged in or manually)
+ Fixed problems with /banlist and also with loading both the ip and player ban files
+ TASK 118418: Make over Welfare.
+ Any mail left on the server now sends a message to allow the user to retrieve it when they want.
+ allowed !Mods to use ListCommmandsCommand again.
+ BUG: factory refesh no working correctly
+ changed other Entity().getShortName() calls to Entity().getShortNameRaw();
+ BUG 1264968: nameing bug
+ BUG 1264969: proto's and the unit vewer
+ BUG 1264971: links not working
+ ShortValidator further refined. Now checking milestones and resources, as well as construction.
+ Added AttackCommand, DefendCommand and TerminateCommand for ops use.
R Client and Server 0.0.20.0
+ BUG: didn't check for backup folder for purge old files for deds.
+ BUG: Fixed change to MM eq call in weaponspecialist skill
+ BUG: didn't check to make sure savegames folder existed for Deds
+ added code to call MM GameOptionsDialog and use and save the gameoptions to the server and send back to the users.
+ BUG 1257784: setting certain MM game options should disable others
+ BUG: loadgamewithfullpath command for ded was passing loadgame
+ Made IM set a 0 bv mod if pilot also posess PR
+ Fixed Issues with 1.5 Conversion.
+ BUG: AutoArchive was setting archive flag before checking if it was time to archive.
+ Fixed tab problem in CCOmmPanel [this.setFocusTraversalKeysEnabled(false);]
+ moved command list UI to admin menu.
+ readded code to parse Terrain server now loads. 
+ Hide MegaMek unit ID#'s in MekWars' MechDetailDisplay
+ BUG: Previews in CamoSelector not working. Removed generic.
+ Remove obsolete converter classes
+ Converstion from 1.4 to 1.5 java.
+ CHSPanel should send "c buypilotsfromhouse" instead of "c buypilotsfromfaction"
+ TASK 117818: Combine Mod and Admin menus into Staff Menu
+ added a CommandDialog.java that shows all the commands they have access too
+ Added server.dataProviderCommandAccessLevels.java to allow users to download all the commands listed and their access levels.

V0.0.19.x (closed 8.15.05, 3 binary releases)
+ BUG: RequestCommand was only removing [Coach] light pilot queues.
+ added archiving check so player files are not saved during archive.
+ set automatic backup to its own thread.
+ fixed typo in AddOmniVariantModCommand.java.
+ added creatunit UI to the ModeratorMenu.java
+ removed debugging messages from RepodSelectorDialog.java
+ found more cbills and influence hard coded messages
+ Servers should ignore dedicated hosts when reporting player counts to trackers
+ [Coach]'s ppq get cleared when they request new units
+ fixed typo in SPlayer (extra s) in money also rogue cbills text removed.
+ fixed CMainFrame. factionstatus command back to housestatus
+ Add "faction" as synonym for "house" is command tree
+ RFE 1259371: activate/deactive button double as login
R Server 0.0.19.4 (Released to SourceForge, 8.14.05)
+ Updated ServerManifest.txt to reflect new location of Ostermiller, TinyXML, collections
+ Added /lib folder to server-dist for MM use. Moved Ostermiller.jar, TinyXML.jar, collections.jar to lib 
+ Removed extraneous kunststoff.jar from server-dist
+ Create the ipbans.txt and accountbans.txt files if they're missing
+ Task 117932: Hide HQ/BM specific config settings when not needed
+ Tracker - faster refresh, shorter waits when blocked
+ BUG: Extra BV column in mechstats
+ Debug code for ClientThread when loading inf pilot skills.
R Client 0.0.19.1 / Server 0.0.19.3 (Released to SourceForge, 8.11.05)
+ Added MM .29-RC4 to CVS
+ added abbrivated Pilot skills to the donate and transfer dialog boxes
R Server 0.0.19.2
+ BUG 1256773: Each task resolution gives a leach attack
+ TASK 116679: Create Money/Flu return method
+ changed all refernce to the word house to the word faction. This should make it more IS/Clan friendly
+ change to shutdown code. Forcesaves everyone one even if they are not in the queue. had a few shutdowns where people lost their stuff.
+ fixed grammer for Direct sell if contacts take 0 the contact message does not print.
R Server 0.0.19.1
+ BUG: Task defender options logging improperly
+ RFE: use 10 minute server reporting periods, instead of 15
+ BUG: Improper day counts from CampaignMain.readibleTime()
R Tracker 0.1.0.0
R Client/Server 0.0.19.0
+ BUG: Deds where not timestamping autosaves
+ fix to automated backup. Had an Int in the formula so it returned an int to the long.
+ Task 107802: Automated Backup
+ Task 117933 - Tracker. Functional. Need to test w/ running servers.
+ BUG: Transferpilot may not send the correct Pilot if you have more then 1 pilot listed
+ RFE 1251108: PPQ donations
+ TrackerThread in MMServ, communicates with MekWarsTracker (incomplete, untested!)
+ updated doPlaySound to use its own thread
+ RFE 1251105: BM purchase notification
+ moved all fields from the New tab to the thier approitae tabs.
+ TASKS 117931: Set Client Options
+ .cvsignore updated, now dieregards MekWarsTracker.jar
+ TrackerManifest.txt added to root directory
+ build.xml updated w/ targets for MekWarsTracker.jar
+ Simple standalone tracker-server. Needs debugging and MekWarsServer support
+ added error reporting to BuildTableListCommand.java to help SO's track down bad file names.
+ TASK 117832: Update client side factories in campaignData
+ TASK 117139: Deds auto clear save files that are X days old.
+ RFE 1231276: move house MOTD to house/main chat
+ RFE 1240896: gui for retrieving megameklog.txt from deds
+ added code to no display buy new/used units when those unit types are not used by the server.
+ added code to allow [Coach] accounts to reset units anytime they want, excluding during combat.
+ RFE 1091217: BV calculator for c3/c3i
+ added searchlight on/off default to CustomUnitDialog
+ Used new active/fighting check code in DirectSellCommand.java
+ Column/sizing improvements for CustomUnitDialog
+ Vertical orientation for CustomUnitDialog. Still need to set up dual columns for long lists, and set min size.
+ Used new active/fighting check code in SellCommand.java
+ Used new active/fighting check code to improve scrap/donate restrictions
+ BUG: Possible to transfer units out of active/fighting armies
+ Changed "ChangeLanceOnActive" default to "false"
+ TASK: added slite selection to custom unit dialog
+ RFE 1167893: Client option for MG burst
+ TASK 117393: Add Dawn option to Advance Terrain
+ RFE 1216554: Allowing Server to Set Cost for Repods Per Varient
+ GetPlayerUnitsCommand added along with LPU command on client. this allows for a unit list to be sent to an admin when using unit related commands.
+ Preserve TableViewer sorting preferences between sessions
+ BUG: Improper char in SplashWindow connection/status roller
+ Tooltips and double-click for detail dialog in client-side table browser.
+ added Units to the text of the unitsmenu item in adminpopupmenu.
+ fixed boolean problem in admin transfer unit popup menu,was looking only at current faction
+ fixed type in the admin donate command
+ BUG: checking for cancel button in menus.
+ BUG: no pplanet being initialed in AdminPopupmenu
+ BUG 1239069: BV of armies with TAG and homing arrow wrong
+ MW needs to be compiled with MM 29.86+ Game Phases have been renumber PHASE_VICTORY is no longer 15 and is not 18.
+ added try/catch code to gameChangePhaseEvent in clientThread.jar
+ CMainFrame autoselects proper table browsing mode (server command or client gui)
+ Sortable client-side table browser (commented out in help menu, work in progress. incompatible with buildtable eras.)

V0.0.18.x (closed 7.24.05, no binary release)
+ Protos with Astech skill no longer get added to the Proto Total when calculating techs need for protos.
+ BUG: Possible fix for ommission of light units in MechStats html output
+ Admin popup menu in userlist (untested)
R Client / Server 0.0.18.0
+ BUG: players could submit negative reward values for some kinds of reward (influence)
+ Updated overlap calculations - weighted army numbers now work with percent caps.
+ BUG: players who've just logged in sometimes logged out by idle-checker
+ BUG: loading savegames not working
+ Use one link-listener for all chat tabs, instead of creating individual listeners
+ Massive rename of MMClient to MWClient, standardized on "mwclient" as ivar name in classes
0 Made above change in order to stop MW and MMNET from grouping together in taskbar
+ Removed unecessary task param IArmy.matches in prep for Ops 
+ Hide "Add to No-Play" option in userlist popup no-play max size is < 1
+ BUG: fixed a bug in the BuildTableListCommand for when viewing not Table files
+ RFE 1227216: New Pilot Skill: Blood Name(Rename to Trait Skill)
+ added AddTraitCommand()
+ added RemoveTraitCommand()
+ Added TraitDialog for player viewing and admin control of Traits.
+ added ServerTrait.java to send trait files from the server to the client.
+ added new TraitSkill.java file

V0.0.17.x (closed 7.23.05, 1 binary release)
+ Move dataprovider calls to infolog (again?)
+ BUG: hm detected improperly for command log suppression
+ Punish players who deactivate when they're actually able to defend a task.
+ BUG: links from displaysavegames where not working.
R Client 0.0.17.3
+ build.xml change: include ./client-dist/lib/ jars in any build path
+ BUG: repodcommand unit model was being added to the variants vector,leacy code that had been over looked.
+ updated contribs and licenses to reflect new lookandfeel libs
+ added many new lookandfeel options to client
+ added /lib to client-dist, moved files as appropriate
+ added data/time stamp to files for display saved games.
+ Added code to load the newest parnoid auto save file on a ded, if used.
+ RFE 1210152: Build list browes command.
R Client/Server 0.0.17.2 [Released to SF as UNSTABLE]
+ Add | to forbidden chars in NamePilot and NameArmy commands
+ When loading game via CMainFrame, open ./savegames
+ BUG: RewardDialog using wrong var for Vehicle cost now uses RewardPointsForAVeh
+ Default isDebug() to "false" (can set "true" w/ CLI argument)
+ Log only incomming commands which are sent for processing, not typos.
+ Save cycle logging moved to infolog, from mainlog
+ Exclude housemails from command log.
+ Commands are already logged to cmdlog, no need to echo in mainlog
+ DataFeed requests moved to infolog, from mainlog
+ SPlayer/SHouse strings moved to infolog, from mainlog
+ Don't log errors when SERVER and Nobody pfiles aren't present
+ added playerdialog to all mod menus that required player name input.
+ BUG: fixed to mod menu so that it displays all submenus
+ TASK 117138: List Saved games from deds.
+ added savegames/ to the load game field.
+ added PlayerNameDialog to the Check menu selection in Moderator Menu
+ BUG: Admin/Mod menus not always showing up for admins and mods.
+ added Navel and VTOL filters to unitviewer.
+ changed Ded backup log file to megameklog.txt
+ BUG: Global global var not getting reset each time the repod command was called.
+ BUG: index 0 when there where no omni mechs to list.i.e. if it was turned off.
R Client/Server 0.0.17.1
+ Changed AdminHouseStatusCommand Now shows the selected houses Bays in the users House Status.
+ Deds always autoconnect
+ Fixed Typo in AdminAllowDefection
+ RFE 1231225: when reloading savegame on ded, copy megamek.log
+ BUG: MaxSOLCBills param not working properly (untested)
+ Changed Code to work with new MM AmmoType.getMunitionType() returns long instead of int now.
+ RFE 1221515: Skill Costs
+ RFE 1155463: RP for factory refresh
+ RFE 1155460: RP for repodding.
+ BUG: planet selected via search not focused for zoom
+ Small re-ordering of bug/rfe links (MW before MM, added a separator)
+ Added code to remove units.cache every time the Client starts.
+ Task 117074: RFE link in MWClient Help menu
R Client/Server 0.0.17.0
+ BUG: Null pointer in house command
+ BUG: looking for camo along wrong path
+ NAME/PATH CHANGE: config.txt renamed mwconfig.txt and moved to ./data
+ Remove Admin.jar from CVS
+ Global repod code added(Needs testing and GUI)
+ BUG 1197347: C3/C3i Linkages are unreliable when launching games
+ BUG 1179030: Mercenary Contract Not Working(Closed and Reopened as a task)
+ BUG 1179434: Binding to any IP (Closed and reopened as a task.)
+ Removed Boolean var from Unit.setPilot() call. not needed.
+ BUG 1229007: after repod, pilot skill ignored for BV calc

V0.0.16.x (Closed 6.28.05 - no binary release)
+ Task 117012: Client Version on splash screen.
+ added code to not allow +|$# in fluffs for the FactionLeaderFluffCommand()
+ Add /c modtasks to Moderator Menu
R Client 0.0.16.7
0 For posterity - Client 16.6 was 1460k. 16.7 is 608k, with a 229k optional Admin.jar
+ Admin and Moderator interfaces broken into seperate jar.
+ TASK 116678: Load Entity from Units.cache
+ Changes to ant build file. Compress jars for >60% space savings.
+ Bug 1227572: Planetary Map Zoom Bug
R Client 0.0.16.6, Server 0.0.16.8
+ RFE 1218814 - Random Repod, now complete
+ GUI for new repod server options, and RepodRandomMod
+ Support for new server options in RepodCommand.java
+ New server option: "AllRepodsRandom", default: false
+ New server option: "AllowRandomRepod", default: true
+ Client GUI for RandomRepod (Random button in dialog)
R Server 0.0.16.7
+ BUG 1226770: Not applying pilot skill BVs
+ BUG: NPE when getting colored name for SPlanets w/ no owner
R Client 0.0.16.5
+ BUG: MAINCHANNELPM's being shown in incorrect colours
+ BUG: IGNORE_HOUSE working incorrectly
R Server 0.0.16.6
+ BUG 1226770: Unit BV's not recalculated after level up (hacky fix. should be cleaned up.) 
+ Moved "repod targed: " log line to w/i loop, so it only shows for change, not query.
R Server 0.0.16.5
+ Prospective fix for BV error (ass BV's calculated as 4/5)
R Client/Server 0.0.16.4
+ Task 112839: Make Defection Penalties, complete. now has GUI.
+ added Random option to Repod no UI added.
+ fix to ammo loader with MM 83 name change to Clan interanl ammo name
+ added .toLowerCase() to any of the AorAn calls that happend in the middle of sentence.
+ BUG: Components should be taken from defending house, not planet owner.
+ Fixed typos in DefectCommand and AdmindAllowHouseDefectionCommand.
+ BUG: was not updating the client when the transferpilotcommand was used
+ Improved PlayerNameDialog's behaviour with empty text field
+ SUnit.setPilot() now sets the same pilot with the same skills to the Entity to calculate the correct BV via MM.
+ Removed bad legacy BV Calulation Code MW side
R Client/Server 0.0.16.3
+ Users want login name saved, as before ...
+ Only store usernames saved in config, not those entered in signondialog
+ Only store passwords saved in config, not those entered in signondialog
+ Autoconnect default changed to "NO"
+ added patch if ammo isn't found use standard(upcoming change in MM code)
+ Banned server ammo loaded gets switched to Standard.
+ removed NU command patch on client.
+ GUI for autoconnect
R Client/Server 0.0.16.2
+ Added Bremmond to contribs
+ Improved output from /c displayplayerpersonalpilotqueue (hides empty classes/types)
+ Improved PPQ menus in the Client
+ Replaced client unit loading stack traces with single-line filename prints
+ Moved excludelis transmission into Shouse.doLogin(), out of SPlayer.fromString()
+ BUG: SHouse was reading DefectTo status when MOTD was blank. now saves MOTD as " "
+ Added code to configure conquers will be removed with Operations
+ Bug: Divide by zero in house status
+ BUG: Component raids where taking components from the Planets owner not the defender.
+ Added GUI for Direct Sell both menus and Server Config for options
+ Tested Defection(Works)!
+ BUG: NPE when client logger receives null strings
+ BUG: Yet more defection bugs. Please, kill me.
+ BUG: Defection penalty string malformed
+ Name and Path changes! new files ./data/accountbans.txt and ./data/ipbans.txt
+ BUG: Defection to faction with 0 players.
+ BUG: Defection with units on BM
+ Path change! countrylist.txt moved to ./data/
+ Path change! iplist.txt moved to ./data/
+ Path change! mails.txt moved to ./data/
+ BUG: The long-awaited fix of "Miscellaneous" spelling.
+ Removed most command-calls to strip links from Misc. tab
+ Moved "Mute" and "No-Play" into block.
+ Userlist shows a + for each additional mute mode [eg - "mute++" for all 3 mute modes]
+ Added Userlist GUI for PM mutes
+ Added Userlist GUI for house mutes
+ Created "Block" submenu in userlist
+ Added option to Fire excess techs via HQ popup
+ Removed BUY options in HQ (which were broken anyway)
+ Selecting unit for sale in HQ opens custom SellUnit dialog instead of a sequential prompts
+ Revised treatment of empty spaces in HQ
+ Revised default buttons on most dialogs
+ Renamed UnitSelector to UnitViewerDialog
+ Added UnitSelectionDialog, used in various transfer commands
+ Added PlayerNameDialog, used in various transfer commands
+ Create client.gui.dialog.* package, moved/updated classes as appropriate
+ BUG: got rid of duplicate users bug when someone logs in quickly twice.
+ added vars for the DirectSellUnit function
+ added GUI for Pilot Transfer.
+ added DirectSellUnitCommand.java
+ Added AorAn.java to common.util, use to check whether "a" or "an" should precede a string.
+ Bug 1217897: Units losing level-ups
+ Task 116584: Activate/Deactivate Button in Userlist
+ RFE 1056249: Config Directory (./data/)
+ Path change! serverconfig.txt moved to ./data/
+ Path change! campaignconfig.txt moved to ./data/
+ Path change! factions.dtd moved to ./data/
+ Path change! factions.xml moved to ./data/
+ Path change! planets.dtd moved to ./data/
+ Path change! planets.xml moved to ./data/
+ Path change! terrain.dtd moved to ./data/
+ Path change! terrain.xml moved to ./data/
+ moved all System.out.println(); to MMServ.mmlog.mainLog();
+ moved all *.printStackTrace(); to MMServ.mmlog.errlog();
+ moved all System.err.println(); to MMServ.mmlog.errlog();
+ Split MMLog to CMWLog and SMWLog on client and server.
+ added Error Log Tab to show all mods/admins errors from the server
+ Added "DefectionEXPLossFlat", default: 0
+ Added "DefectionCBillLossFlat", default: 0
+ Added "DefectionRewardLossFlat", default: 0
+ Added "DefectionInfluenceLossFlat", default: 0
+ Added "DefectionUnitLossFlat", default:
+ Added "DefectionEXPLossPercent", default: 25
+ Added "DefectionCBillLossPercent", default: 25
+ Added "DefectionRewardLossPercent", default: 0
+ Added "DefectionInfluenceLossPercent", default: 100
+ Added "DefectionUnitLossPercent", default: 100
+ Added MWDEFECTDLG link for defection confirmation
+ Task 112839: Make Defection Penalties Configurable
+ added new commands SetHouseConquer SetHouseInHouseAttacks SetPlanetConquer should me it easier for the admins not having to SD the server and edit these by hand.
+ try/catch added to CUnit.setData() incase the ammo ammounts on the server do not match the ammo amounts on the client.
+ small formatting fixes to /c house display of running games
+ formatting improvements in HSPanel's unit lists
+ added transferpilotcommand.java
+ RFE 1184778: transfer of pilots
+ RFE 1211645: do server ammo ban based on munitionType, not on AmmoType
+ BUG: ArrayOutOfBounds error in ServerConfigPage
+ BUG: Tech level sorting not working in UnitViewer (need to add L3?)
+ BUG: divide by 0 error in /c house if no players of the house have logged in since last reboot
+ Optomization - use raw booleans for server-sends from ServerConfigPage
+ Optomization - use static calls to Boolean, Double, Float, Long
+ DefaultOperation changed to use Strings, a la ServerDefaultoptions
+ Use static Integer.parseInt() instead of new Integer(string).intValue in as many places as possible
+ Use static Boolean.toString() and Boolean.getValue(String s) in ServerConfigPage
+ GUI for ScrapsAllowed/DontionsAllowed settings
+ Added "DonationsAllowed", default: 2 per tick
+ Added "ScrapsAllowed", default: 1 per tick
+ Task 116302: Scraps/Tick Configuration
R Client/Server(0.0.16.0) 
+ BUG: When AdvanceTerrain is on if you added Terrain to a planet an Advance Terrain isn't created to shadow it
+ CreateUnitDialog no longer displays banned ammo in the ammo list boxes
+ Allowed Housebanned ammo to be saved in House.java and send to client via binwriter
+ Created AdminSetHouseBannedAmmo
+ Created AdminListHouseBannedAmmo
+ added ServerBannedAmmo to Binwriter
+ added ServerBannedAmmo hash to CampaignData. 
+ changed ban ammo to be based on munition type instead of ammo name. i.e. Thunder and Inferno vs Thunder LRM-20 LRM-15 etc
+ BUG: fixed problem with house specific pilotnames not being pulled.
+ updated Createunit command now enter 99 for gunnery or piloting to create a vacant unit
+ RFE 1218786: show faction economic value in quick link output
+ moved online help to client side only. Should lower bandwidth quite a bit. Leaving helpcommand in for a bit

V0.0.15.x (Closed 06/08/2005, no binary release)
+ added missing file for MM
+ Update to newer MM version, fix build bustage
+ BUG: Pilots where losing exp when being added to a new unit.
+ BUG 1203784: C3 Company linkage not supported by GUI?
+ java.util Hashtable instead of sun.collections Hashtable in WeaponSpecialist
+ Use coloured planet links in tasks as well ...
+ RFE: Show owner colour and % on contested worlds in /c house return
+ RFE: Alpha-sort planets in /c houses return
+ Added SPlanet.getNameAsColoredLink()
+ Make better use of Boolean's static toString() in ConfigPage
+ RFE 1197859: Chat image blocking (and associated GUI)
+ BUG 1198029: Mechstats output [Modified BV removed, record updates resumed]
+ BUG 1108119: Units Returning to Seller from BM come Unmaintained (Again)
+ RFE 1076505: /c range#Distance#FactionName#true to return only in-range factories owned by faction. No GUI yet.
+ BUG 1211510: "status for icon". Not fixed. Note added that feature will not work on some platforms. 
+ RFE 1121663: Range Calculator and Couldn't Find Name
+ BUG: Possible to retire pilots when active or fighting
+ Fix for "Current Tasks: none" in /c house
R client/server(0.0.15.2)
+ added techs need to maintain a unit in the HelpCommand
+ when unenrolling now the password is deleted from the password file
+ started On-Line Help to be done client side, needs bin changes will do when updating to 16 as this would change client/server comms
+ Prospective fix for HQ-overdraw bug. Needs testing.
+ Added MWUSERRO link to SPlayer.checkXPReward() return
+ Added MWUSERRP link to grantreward
+ Added suppot for MWUSERP links, which open the RPDialog
+ BUG: Different colour modes being applied to incoming and outgoing PMs
+ Fixed formatting errors in SellUnit dialog when Comments displayed
+ Fixed a few /c house formatting errors (problems w/ empty lists)
+ Added house-links to campaign.util.Statistics ranking output (show @ ticks)
+ Added .getColoredNameAsLink() and .getNameAsLink() to SHouse
+ Complete rewrite of /c house#name
+ Converted SHouseData's Planets Hashtable into a TreeMap for alpha ordering
+ BUG: menu dividers drawn when no inf/protos present
+ New BM params added to ServerConfigPage @ New Options tab
+ Client GUI adjustments to conform w/ server's "DisableMarketComments" setting
+ Added "DisableMarketComments", default: true
+ Added "MinimumBMSalePrice", default: 5
+ Added "MinimumBMSaleTicks", default: 5
+ RFE: "Infantry" and "Proto" to Add/Exchange menus in HQ. Note: Infantry includes BA.
R Client/Server(0.0.15.1)
+ fix to maxSOLCBills in ServerConfigDialog.
+ disclaimer at the bottom of HouseStatusCommand that numbers are since last reboot.
+ Minor changes form House to Faction in HouseStatus and HouseRankings
+ fix to the AdminSaveCommandLevels Now it will create the commands folder if it does not exsit.
+ added FactionLeaderMuteCommand
+ added FactionLeaderFluffCommand
+ Show target computer in MechDisplay for tanks,
+ BUG 1213491: fix MechDisplay for equipment that has modes.
+ BUG: ProtoMek's critical slots displayed wrong in MechDisplay.
+ RFE: Limited configurability of server message colours. Works with most, but not all, "red" messages.
+ Added GUI for UserList settings (bold, show images, etc)
+ Commented many variables w/ GUI options out of intial config.txt output. Move towards necessary values only.
+ RFE: Configurable challenge strings
+ BUG 1210608: Changed map menu CBoxes to JCheckBoxMenuItems for 1.5 compatibility
+ RFE: Option to suppress Enter/Exit messages
+ Fix to allow Deds to send Mod Mail again.	
+ Fix to allow users to see MM if their access level is lower then MOD
+ BUG: link-selected planets not saved for next session
+ BUG: unlinked planet names in ComponentRaid
+ Fixed the Map colors now show on planets. Added # check to StringConverter
R Client/Server 0.0.15.0 (06/01/2005)
+ REF 1189744: Static maps in the terrain.xml
+ REF 1189747: temperature for individual terrain types.
+ Fixed Mod Mail, access control was added but messages didn't go to the Mod mail.
+ Finished Advance Terrain and Static maps.
+ BUG: Protos where using the Light Mech count when displaying proto count for MPC in CHQPanel.
+ added Battle Armor to the MPC code in CHQPanel.
+ fixed typos in the MPC Code in CHQPanel. 2 characters where getting cut off instead of the .
+ Fixed getNameAsLink() was playing the planet name twice once as a link once not.
+ removed MMServer CLIENTVERSION. replaced it with editing the Server Verison on the fly for the same effect
+ Advence Terrain code added, not tested editor works.
+ possible fix for c3 linking
+ Return links in /c iss and /c range as well. [Aside: these commands should be moved client side, soon]
+ Tasks return link-names in info (/c tasks, etc). Other uses?
+ RFE: Planet links. Example: <a href="JUMPTOPLANETSolaris VII#">Solaris VII</a>
+ Temp GUIs for MaxWelfarePerTick and MaxSOLCBills in "New Options"
+ RFE: MaxWelfarePerTick, default: 5
+ RFE: MaxSOLCBills, default: 300
+ "BV: " instead of "Real BV: " in SArmy output
+ "SignOn" & "SignOff" replaced with "Enter" & "Exit"
+ Modified Server/Client version output during sign-on.
+ made a small change to Tasks where with PPQ pilotdied wasn't always being set.
+ RFE: "Request Match" menu when right-clicking Army in HQ.
+ added more to the advance terrain features. Frame work in need to add commands.
0 Thanks urgru for getting it started once I saw what you did I knew how to finish it.
+ Redid list commands output to display in HTML table. better format.
+ added gui for AdminSetCommandLevels
+ added gui for AdminSaveCommandLevels
+ added Loading of command levels to commands.dat after Command hash is loaded in the code
+ added AdminSaveCommandLevels saves commands and their levels to ./data/commands/commands.dat
+ added AdminSetCommandLevel
+ moved listcomands to reg level now only displays your current level in commands. i.e. reg players will not see admin/mod commands
+ changed if(userLevel < accessLevel) { to if(userLevel < getExecutionLevel())
+ fixed problem with compiling with new MM for DetailedMekdisplay.
+ added swamps to ClientThread.java for MM RMG

V0.0.14.x (Closed 5/28/05 - No Binary Release)
+ Added default levels to commands (prep for configurability, should not impact fucntionality)
+ Removed ForceActivateCommand.java, obsolete
+ Removed IGNOREDATAFEEDER in prep for Ops changes, and in response to ELO-access circumvention bug.
+ fixed Auto BM units so that they use the class price instead of all Mek prices.
+ added adminexchangeplanetownership command
+ if the Server motd is changed using /setmotd the serverconfig.txt is saved with the new data
R Client/Server 0.0.14.0
+ Some merc changes. Decided to place on hold until after operations and revamp the merc code to fit with that.
+ changed Lightyears from Terra to Lightyears from the galaxy center
+ BUG: with PPQ on salvaged vehicles where not given new crews!
+ BUG: MegaMek Options are now saved to the MW client again.
+ Added new feature to allow players buy from a specific factory in the house bays. Not just from a specfic planet as before.
+ BUG: Idle kick not working p.getActivityStatus() >= SPlayer.STATUS_LOGGEDOUT instead of p.getActivityStatus() <= SPlayer.STATUS_LOGGEDOUT

V0.0.13.x (Closed 18/05/05 - No Binary Release)
R Client 0.0.13.1 / Server 0.0.13.1
+ updated MegaMek.jar to make MW compile again
+ fix bug cause by recent MM refactoring
+ added the trim() method to the get unit name in the donatecommand.java
+ Removed Monatry units in BuyPilotsFromHouseCommand.java and replaced with MoneyShortName var
+ BUG: armies not being properly displayed in /c mystatus
+ bug fixed clientthread issues --Thanks BeeRockxs
+ bug PM message wasn't being parsed out of the PM command token string.
+ fixed missing space in donate text

V0.0.12.x (Closed 05/10/05 - No Binary Release)
+ Fixed some typos.
+ Crazy Go Nuts! STH in HQ!
+ Playerlist "Sort By House" changed to "Sort By Faction"
+ Whoops. Don't let admin's send player info to  their house streams from adminplayerstatus.
+ SPlayer.getStatus() sends links (via /c mystatus) to use w/ ShowToHouse [UNTESTED]
+ New ShowToHouse command to send info on a specific unit or army to house chat.
+ Improved SArmy.getDescription() methods
+ BUG: Can't set blank name (ie - no name) when renaming armies.
+ RFE 1196117: "Remove from all armies" option in the Hangar
+ Removed "Tactics Hints" option in HQ
+ Fixed a minor bug in HouseNameDialog
+ Show new BV when units are removed from armies with ExchangeUnitCommand, same as when adding.
+ BUG 1196311: no play bug
+ Added calls for the New  PlanetNameDialog and HouseNameDialog to CMainFrame.java MenuFactory.java and TaskActionListener.java
+ Added new PlanetNameDialog.java and HouseNameDialog.java returns the select house/planet name
+ Make CANCEL default option when confirming defection in client
+ Save map view (planet, zoom, etc.) between sessions
+ Improved planet search on map (PlanetSearchDialog.java)
+ New command, GUI additon (ModTasks - shows all tasks as if mod is in same house as one of task's players) [UNTESTED]
+ Apply chat colour settings/preferences to Private Message tab [UNTESTED]
+ Default WS, TG, G/L, G/B and G/M pilot skills to 0 appearance
+ Global search and replace of all ProtoMech with ProtoMek found vars that where still referecing the old stuff. bug will need to be shaken out.
+ added option for SO's to select what weapons they do not want Weapon Specalist to be allowed with.
+ MW now reports finished MM Games.
+ made unit with pilot advantages loading work with new MegaMek version
+ updated MegaMek.jar, changed ClientThread to deal with MegaMek's refactored GameEvent handling.
+ added some more user friendly terrain stuff to the admin menus. (gearing up for terrain overhaul)
R Client 0.0.12.8 / Server 0.0.12.9
+ BUG: 1188430 Leveling Bug: Math Error?
+ ISS now takes a thrid parameter so you can enter 2 house names and it'll display planets where both hosues exist.
+ updated ISS not is plantary control and Universe Status enabled menu option
+ Added code to allow SO's to kick idle users. defaults to 0 off
+ Rewrite of EnrollCommand
+ Rewrite of UenrollCommand
+ Send /c enroll link to non-campaign players when they sign on
+ updated online help and CHSPanel for more stream line code and more info to the users.
+ Replace all viewable instances of "ProtoMech" with "ProtoMek"
+ Revisions to RP Dialog - vert stacking instead of 2x2 grid), string changes
+ used MenuFactory to add the task menu to the menu bar. (removed duplicate code in CMainFrame)
+ added RPs to the mod check command.
+ added Server Options for Reward cost for Proto and Battle Armor
+ added Reward Point Dialog box. Now you can see before you spend!
R Server 0.0.12.8
+ NPE in ExchangeUnitCommand
R Client 0.0.12.7 / Server 0.0.12.7
+ Restored sorting on login
+ RFE: 1176926 Daemonize the server
+ RFE: 1183933 Variable Value on Units for Techs
+ RFE: 1172985 no feedback when trying to control ded and not on ownerlist
+ Task: 114419 Configurable Money and Flu Names
+ RFE: Improve techs-quit message, automove players to reserve if appropriate.
+ RFE 1176932: GUI completed
+ Option to use normal (colored, bold) names in /me's
+ Option to look for keywords in all messages (System, as well as chat)
+ Split chat and sound tabs in ConfigPage
+ Toggle or change keyword sound w/o restart
+ Toggle or change call sound w/o restart
+ Toggle or change mail sound w/o restart
+ Toggle or change attack sound w/o restart
+ RFE 1176932: Faction colors for player names [GUI forthcoming]
+ Don't look for pfiles for Dedicated hosts
+ Task: 114419 Configurable Money and Flu Names
+ RFE: Give user a link to perform a /c ca when OLH info changes
+ BUG: Unit viewer can't be closed if no unit is selected (again)
+ Reset BM timer in response to all refresh commands
+ Reset player's BM refresh counter on login
+ RFE: Inform players when they try to repod a unit and no alternative configs exist.
+ Don't allow Error units in armies
+ Hide buy pilot choices in HS if queues are disabled
R Client 0.0.12.6 / Server 0.0.12.6
+ Gunnery Skill and Weight Class sort option in HQ
+ Added olderhistory.txt. Moved pre-0.0.9 commits to new file.
+ OK button selected by default in camo dialog
+ RFE: BM preview image (and related config options)
+ Tweaks to splash info timing (corrected "Fetching Data" appearance time)
+ changed all references to MU to moneyShortName or MoneyLong name so SO's can configure them as they see fit.
+ added moneyShortName and moneyLongName to configs. 
+ RFE 1181835: Sorting of camos in HQ camo selector
+ changed all references to CBills to MU(Monatary Units)
+ Fixed typo in Tasks.java on one to no one
+ RFE 1181288: Industrial Accidents Flooding Main Channel
R Server 0.0.12.5
+ I'm an idiot did a check for the same unit being in an army and check the old unit instead of the new.
R Client 0.0.12.5 / Server 0.0.12.4
+ RFE: Option to show unit image in BM tab
+ removed alot of redundent imports where Unit and SUnit where being imported in the same file.
+ added new code to allow SO's to give ba's and protos to SOL
+ BUG: BV on server site now sets and returns 0 if BV is less then 0
+ BUG: House Status window showing Proto and BA factories when not being used.
+ BUG: if a player unenrolls before a task reports at the tick it fubars the system.
+ BUG: Proto and BA's getting created as lights.
+ BUG: Proto and BA Factories Not Refreshing
+ BUG: duplication of code in CheckCommand.java
+ BUG: No-play case sensitivity
+ Map Darkness configurable
R Client 0.0.12.4 / Server 0.0.12.3
+ Kill "Vacant" pilots entering house queue.
+ Handle OMG's better client-side
+ Client pilot retirement changes, Server Config Page update
+ Prevent Vacant pilots from being reintroduced when purchasing from house
+ Enhanced pilot retirement options [Server only - client update coming]
+ Sort order above sort choice in playerlist popup
+ Updated "Click here to reset your units" link in RequestDonated/Request
+ Additonal Hangar sorts [Pilot Kills, Walking MP, Jumping MP]
+ Show "Reset Units" button in HQ for SOLs
+ Relocated Mod popup menu in userlist, used submenu
+ Removed CheckVersion command. Incorporated Client version into /c check output.
R Server 0.0.12.2/Client 0.0.12.3
+ TASK 114184: Save House MOTD
+ TASK 114174: Mod User List Right Click Menu.
+ TASK 114173: Mod Menu
+ RFE 1177319: default to Common build list
+ added adminlistandremoveomg command this will search all of the house bays for OMG files list the file name its looking for then remove it from the house bays
R Server 0.0.12.1/Client 0.0.12.2
+ BUG: problems with name formatting.
+ BUG: meks where being produced no matter the factory type.
+ TASK 113834: Repod Dialog
R Client 0.0.12.1
+ RFE 1119093: Mech bays [hangar sorting]
+ Made the camo selection dialog slightly wider
+ Scroll UnitViewer while searching in response to keystrokes
R Client/Server 0.0.12.0
+ UnitViewer's JList requests focus

V0.0.11.x (Closed 04/03/05 - No Binary Release)
+ BUG: AMS was getting listed as a WS weapon.
+ TASK 113838: configurable convert captured mw option.
+ TASK 113837: Allowed Downed Mech PIlots to be captued option
+ Disable Add and Exchange menus in HQ if all units are in maxarmies
+ Disable /c ca menu option in HQ for players who are in reserve if ProbeFromReserve=false
+ Save users when they reorder armies or modify no-play's
+ RFE: Allow users to select unit positions in HQ
+ Don't show mute/no play/transfers when right clicking oneself in player list
+ Finalized no-plays. Show in /c mystatus, GUIed via player list, configs in ServerConfigPage
+ Converted Armies from HashTable to Vector.
+ RFE 1103592: Separate Factory Types for BA and Protos
+ RFE 1109688: Campaign pilot changes- pool, organization and supply
+ TASK 113836: Eye Candy for Piloting Skills
+ Preliminary no-play commit. Exclusions work, pricing/final GUI impending.
+ Improved Limiter dialogs in Client
+ BUG: Limiters checking own values instead of enemy values when Infantry counting
+ BUG: Negative value limiters wrapping back as positives
+ Improved output in upper/lower limiter sets (show army impacted)
+ Show players when they've received fluff.
+ Added GUI Server Options for Personal Pilot Queues New Pilot Tab
+ GUI added for Personal Pilot Queues, more to come.
+ BUG: fixed problem with BM not loading units correclty added toClient boolean to the bm save/display.
+ added client side PersonalPilotqueue and Added CHQ gui to remove and swap pilots.
+ added command ExchangePilotInUnit and DisplayPersonalPilotQueue.
+ Personal pilot queues added. saved and loading as well as sending data to client.
+ Open DetailDialog when BM is double clicked
+ Complete rewrite of BM buttons and dialogs
+ RFE: Preserve Unit Viewer settings between sessions
+ RFE 1162529: adding number of infantry a APC can carry
+ RFE 1163458: auto-attack options after immunity expires
+ Save BM sorting preferences between client sessions
+ Restore sort order after BM refresh
+ RFE: Sort BM columns w/ left clicks
+ RFE: Config option to replace server icon w/ activity status
+ RFE: Added "Select Camo" button to HQ
+ RFE: Remove "Select Camo" from config dialog 
+ Broke CamoDialog into discrete class
+ Converted HS buttons to springs
+ Moved "Buy" button from HQ to HS. Split into "Buy New" and "Buy Used"
+ Reorder fails in RequestDonated in order to match Request
+ Converted HQ button row to SpringLayout
+ RFE: Add "Remove All Armies" button in HQ
+ RFE: Remove "Join" and "Host and Join" buttons in HQ
+ RFE: "Last Refresh" info in BM button
+ added defaults for proto and BA's for skills.
+ added Client GC at the Tick.
+ Task 113702: User Configurable AutoScrap Messages
+ fixes to the Infantry split. also added a unit 2 tab for control of proto/ba cost pp and flu
+ Start of spliting BA&Protos From Infantry, Compiles and loads. BA's not getting comps right now more to be added.
R Client/Server 0.0.11.1
+ added abberviated pilot skills to the adminhousepilots command out put.
+ Task 112833: Track Vehicle omnis from flat file for servers
+ Print a simple "No serverdata.dat" log line instead of complete stack trace.
+ Fixed .show() calls. Again. Whoops. [I'm a moron @urgru]
+ Changed show() timing in MMClient, disabled CH autoraise
+ BUG 1162177: Wrong inf weight class after being autoproduced
+ Server vars will now return a -1 instead of shutting down the server also a message will be sent to modmail.
+ BUG: added a check in client CH command to set the mainframe visible if not a ded
+ BUG: Survivalist and Iron Man skills being given to Vee's and Inf
+ Hide limit ranges in client if AllowLimits == false.
+ BUG: Server doesn't compile. Whoops.
+ BUG: Could not set limits equal to the buffer
R Client/Server 0.0.11.0

V0.0.10.x (closed 3.12.05)
+ added 8 new pilot skills
+ added loadpilot to the pilotqueue.java this loads a pilot from a saved house queue and doesn't touch the skills/abilities
+ fixed error with loading house pilot queues. Base gunnery/piloting wasn't getting set until after the queue was loaded
+ Added a code so that serverdata.dat updates config.txt and then is removed. Stealth client var updates
+ RFE 1155472: Support for all coded MegaMek Skills
+ RFE 1155470: Configurable pilot skills
+ updated client mirror of config defaults
+ RFE: Adjust limits within buffers when saved players are loaded (to handle setting changes)
+ RFE: Added new "DefaultLowerLimit" option to server, applied when player adds new army
+ RFE: Added new "DefaultUpperLimit" option to server, applied when player adds new army
+ RFE: Hide options to set limiters in client if "AllowLimiters" is false
+ RFE: Added new "UpperLimitBuffer" option to server
+ RFE: Added new "LowerLimitBuffer" option to server
+ RFE: added new "CountInfForLimiters" option to server
+ RFE: added new "ShowInfInCheckattack" option to server
+ RFE: added new "AllowLimiters" option to server
+ RFE: Exclude "Error OMG" from Unit Viewer listing 
+ BUG: Server file (CampaignMain) called from client.MMClient
+ BUG 1155409: army name missing when creating army with the BV calculator
R Client 0.0.10.5/Server 0.0.10.2
+ TASK 112923: Redo Rewards code
+ RFE 1155269: RP Build list changes
+ TASK 112808: Move Repod View Unit to Local commands
+ TASK: Added new clientCloseListener from MM.
+ TASK 112807: save master unit count to flat file
+ RFE: Save player list sort mode/order between sessions
+ Save option menu's "Auto Scroll" setting between sessions
+ Save option menu's "Mute" setting between sessions 
+ Construct, but do not display, "Show FASA BV" checkbox
R Client 0.0.10.4
+ Removed 5 second wait in gamePlayerStatusChange [long pauses created perception of lag]
R Client 0.0.10.3
+ Converted scheme/laf Radio Buttons into Combo Boxes
+ Moved some things to Host tab
+ Put player list sorts into a submenu
+ Configurable name/icon for MainFrame
R Client 0.0.10.2/Server 0.0.10.1
+ BUG: Added sleep to game update so it will allow everyone to exit first.
+ BUG: gameCount for the Ded autorestart was not getting reset to 0 when the ded autorestarted.
+ BUG: Able to Repod while active.
+ RFE 1151507: One click auto-eject disable
+ BUG 1154805: All Infantry Are Lights after server reset
+ BUG: I was changing units with 0 ids to new ids this cause a mismatch now units with 0 id's get sold by solaris, this should rarely happen with the new code. (knock on wood) --Torren
+ BUG: I added code to give id's to units that load with an id of 0 this however did not compenstate for the armies. This would keep people from loading if they had an 0 unit in an army this is now fixed. --Torren
R Client 0.0.10.1
+ TASK 112806: Add GUI Diaglog for setting up a client as a ded
+ BUG 1145860: Show unit returns wrong pilot skills
+ BUG 1145969: BM Disappears after adding unit
+ New Splash Images [courtesy Ajax]
+ Auto Login
+ Load ServerConfig less often
+ typo fixes in precompute messages

V0.0.9.x (closed 2.26.05 - No Binary Release)
+ added fix if unit loads with id 0 to give it a new id. SUnit.fromString();
+ Removed misc debug messages
+ added var for serverdata.dat so servers can send thier ip and ports without sending config.txt 
+ Fix for inf_proto var for MM
+ RFE 1123504: autoi reset for deds
+ RFE 1123521: c3 variants on BM
+ BUG: BM units reloading after a server reboot have a 0 id if the id is zero set to the next current ID.
+ BUG: fixed problems with BM loading bad units now returns the string, not used, as well as the Unit getting set.
R Server 0.0.9.3
+ BUG: Armies not removable
R Client 0.0.9.1/Server 0.0.9.2
+ Show old name when renaming armies.
+ Show "..." when chopping long army names in HQ.
+ added commands to change name comment and max players for deds
+ added more error catching code for loading houses, units and planets
+ Task 112294: Catch NPE when OMG try to load ammo.
+ Task 112291: Add Proto/Inf cluster option to MW
+ Allow users to change look and feel in client config.
+ Show stalls in splash screen.
+ Splash image, courtesy of Ajax
+ Splash screen loads both JPG and GIF files.
+ BUG: One off error in SOL unit reset code
+ Added Splash Screen [Based on Imi's work in MMNET.]
+ Added IGNOREDATAFEEDER option
+ Removed most OldStyleTab layouts
+ Misc. string fixes. mek -> unit, etc.
+ Allow a player to remove empty armies while active
+ Don't allow a player to make new armies while active
R Server 0.0.9.1
+ Don't hammer the map looking for updates.
+ BUG: New Error unit [MM stopped handling misallocated heatsinks]
+ BUG: NPE w/ SS command.